import ctypes

# Operation mode only for Lora
class OpModeBits(ctypes.LittleEndianStructure):
    _fields_ = [
        ("Mode",              ctypes.c_uint8, 3),
        ("Unused",            ctypes.c_uint8, 3),
        ("AccesSharedReg",    ctypes.c_uint8, 1),
        ("LongRangeMode",     ctypes.c_uint8, 1),
    ]


class RegOpMode(ctypes.Union):
    _fields_ = [
        ("bits", OpModeBits),
        ("octet", ctypes.c_uint8)
    ]    


if __name__ == "__main__":
    c=RegOpMode()
    c.octet=0x00
    c.bits.LongRangeMode=0x01
    print(hex(c.octet))

    c.octet=0x01
    print(hex(c.octet))