from mttkinter import mtTkinter as tk
import ttk
import sys
import sx1272 as sx


import PeriodicThread
import matplotlib
from matplotlib.backends.backend_tkagg import FigureCanvasTkAgg, NavigationToolbar2TkAgg

from matplotlib.figure import Figure
#import matplotlib.animation as animation
from matplotlib import style
import time
import tkFileDialog as fd

style.use("ggplot")



#c=sx.SX1272()

class StdRedirector():
    def __init__(self, text_widget):
        self.text_space = text_widget

    def write(self, string):
        self.text_space.config(state=tk.NORMAL)
        self.text_space.insert("end", string)
        self.text_space.see("end")
        self.text_space.config(state=tk.DISABLED)

class Aplicacion():
    def __init__(self):
        self.raiz = tk.Tk(mt_check_period=1,mt_debug=0)
        self.raiz.geometry('1625x976+0+0')
        self.raiz.title("Sniffer")
        self.raiz.protocol("WM_DELETE_WINDOW", self.on_closing)
        self.thr=PeriodicThread.PeriodicThread(self.update,0.01)
        self.lora=sx.SX1272()

        # Declara variables de control
        
        
        self.codingraten=tk.IntVar(value=5)
        self.spredingfactorn=tk.IntVar(value=7)
        self.bwn=tk.IntVar(value=125)
        self.preamblelenghtn=tk.IntVar(value=8)
        self.setchanneln=tk.DoubleVar(value=387.3984375)
        self.crcn=tk.StringVar(value='ON')
        self.setpowern=tk.IntVar(value=14)

        

        #Frames
        self.Frame1 = tk.Frame(self.raiz,bd=2,relief=tk.RAISED)
        self.Frame11 = tk.Frame(self.Frame1,bd=2,relief=tk.RAISED)
        self.Frame12 = tk.Frame(self.Frame1,bd=2,relief=tk.RAISED)
        self.Frame13 = tk.Frame(self.Frame1,bd=2,relief=tk.RAISED) 
        self.Frame14 = tk.Frame(self.Frame1,bd=2,relief=tk.RAISED) 
        self.Frame15 = tk.Frame(self.Frame1,bd=2,relief=tk.RAISED)
        self.Frame16 = tk.Frame(self.Frame1,bd=2,relief=tk.RAISED)    
        self.Frame2 = tk.Frame(self.raiz,bd=2) 
        self.Frame21 = tk.Frame(self.Frame2,bd=2,relief=tk.RAISED) 
        self.Frame22 = tk.Frame(self.Frame2,bd=2,relief=tk.RAISED)
        self.Frame23 = tk.Frame(self.Frame2,bd=2,relief=tk.RAISED)
        self.Frame3 = tk.Frame(self.raiz,bd=2,relief=tk.RAISED)
        self.Frame4 = tk.Frame(self.raiz,bd=2,relief=tk.RAISED)
        self.Frame5=tk.Frame(self.raiz,bd=2,relief=tk.RAISED,height=15)


        #Matplot

        self.f = Figure( figsize=(20, 6), dpi=80 )
        self.ax=self.f.add_subplot(211)
        #self.ax0 = self.f.add_axes( (0.05, .05, .50, .50), axisbg=(.75,.75,.75), frameon=False)
        self.ax.set_xlim(0,500)
        self.ax.set_ylim(-80,-20)

        
        #self.line,=self.ax.plot([], [], lw=2)
        #self.line.set_data([1,2],[1,2])
        #self.ax.plot([1,2],[20,20],marker='o',linestyle='-',color='r')
        #self.ax.plot(3,20,marker='o',linestyle='--',color='r')

        #self.x=0
        #self.y=0
       

        #self.ax.set_xlabel( 'Packet Number' )
        self.ax.set_ylabel( 'RSSI (dbm)' )

        
        self.ax1=self.f.add_subplot(212)
        self.ax1.set_xlim(0,500)
        self.ax1.set_ylim(-20,20)
        self.ax1.set_xlabel( 'Packet Number' )
        self.ax1.set_ylabel( 'SNR (db)' )

        self.canvas = FigureCanvasTkAgg(self.f, master=self.Frame3)
        self.canvas.get_tk_widget().pack(side=tk.TOP, fill=tk.BOTH, expand=1)
        #self.canvas._tkcanvas.pack(side=tk.TOP, fill=tk.BOTH, expand=True)
        #self.canvas.draw()

        #Toolbar
        self.toolbar = NavigationToolbar2TkAgg(self.canvas, self.Frame3)
        #self.toolbar.update()
        self.canvas._tkcanvas.pack(side=tk.TOP, fill=tk.BOTH, expand=True)

        #Textbox
        self.text_box = tk.Text(self.Frame4, state=tk.DISABLED,height=0,width=0)

        sys.stdout = StdRedirector(self.text_box)
        sys.stderr = StdRedirector(self.text_box)

        #Scrollbar
        self.scrollb = tk.Scrollbar(self.Frame4, command=self.text_box.yview,orient=tk.VERTICAL)
        self.text_box['yscrollcommand']=self.scrollb.set

        #Canvas
        self.circle=tk.Canvas(self.Frame5,width=15, height=15, bg='#F0F0ED')
        self.item=self.circle.create_oval(2, 2, 15, 15, width=1, fill='')



        #Labels
        self.etiq1=tk.Label(self.Frame11,text='Coding rate:')
        self.etiq2=tk.Label(self.Frame11,text='Spreading factor:')
        self.etiq3=tk.Label(self.Frame11,text='Bandwidth:')
        self.etiq4=tk.Label(self.Frame13,text='Preamble lenght:')
        self.etiq5=tk.Label(self.Frame13,text='Channel:')
        self.etiq6=tk.Label(self.Frame13,text='CRC:')
        self.etiq7=tk.Label(self.Frame15,text='Set power:')
        self.etiq8=tk.Label(self.Frame5,text='Receiving:')


        #Inputs
        self.codingrate=ttk.Combobox(self.Frame12,textvariable=self.codingraten,width=10)
        self.codingrate['values']=(5,6,7,8)
        self.spredingfactor=ttk.Combobox(self.Frame12,textvariable=self.spredingfactorn,width=10)
        self.spredingfactor['values']=(7,8,9,10,11,12)
        self.bw=ttk.Combobox(self.Frame12,textvariable=self.bwn,width=10)
        self.bw['values']=(125,250,500)
        self.preamblelenght=tk.Entry(self.Frame14,textvariable=self.preamblelenghtn,width=13)
        self.setchannel=tk.Entry(self.Frame14,textvariable=self.setchanneln,width=13)
        self.crc=ttk.Combobox(self.Frame14,textvariable=self.crcn,width=10)
        self.crc['values']=('ON','OFF')
        self.setpower=tk.Entry(self.Frame16,textvariable=self.setpowern,width=13)
        self.st = tk.Button(self.Frame21, text="Start/Stop", command=self.start,width=15)
        self.data = tk.Button(self.Frame22, text="Data logger", command=self.datalogger,width=15)
        self.tx = tk.Button(self.Frame23, text="TX", command=self.TX,width=15)


        #Positionig labels and inputs
        

        self.etiq1.pack(side=tk.TOP)
        self.etiq2.pack(side=tk.TOP)
        self.etiq3.pack(side=tk.TOP)
        self.codingrate.pack(side=tk.TOP)
        self.spredingfactor.pack(side=tk.TOP)
        self.bw.pack(side=tk.TOP)
        self.etiq4.pack(side=tk.TOP)
        self.etiq5.pack(side=tk.TOP)
        self.etiq6.pack(side=tk.TOP)
        self.preamblelenght.pack(side=tk.TOP)
        self.setchannel.pack(side=tk.TOP)
        self.crc.pack(side=tk.TOP)
        self.etiq7.pack(side=tk.TOP)
        self.setpower.pack(side=tk.TOP)
        self.st.pack()
        self.data.pack()
        self.tx.pack()
        self.text_box.pack(side=tk.LEFT,expand=tk.YES,fill=tk.BOTH)
        self.scrollb.pack(side=tk.LEFT,fill=tk.Y)
        self.circle.pack(side=tk.RIGHT)
        self.etiq8.pack(side=tk.RIGHT)





        #Positioning Frames
        self.Frame1.pack(side = tk.TOP)
        self.Frame11.pack(side = tk.LEFT)
        self.Frame12.pack(side = tk.LEFT)
        self.Frame13.pack(side = tk.LEFT)
        self.Frame14.pack(side = tk.LEFT)
        self.Frame15.pack(side = tk.LEFT)
        self.Frame16.pack(side = tk.LEFT)
        self.Frame2.pack(side=tk.TOP)
        self.Frame21.pack(side = tk.LEFT)
        self.Frame22.pack(side = tk.LEFT)
        self.Frame23.pack(side = tk.LEFT)
        self.Frame3.pack(side = tk.TOP,fill=tk.BOTH)#expand=tk.YES)
        self.Frame4.pack(side = tk.TOP,fill=tk.BOTH,expand=tk.YES)
        self.Frame5.pack(side=tk.TOP,fill=tk.BOTH)#expand=tk.YES)

        
        
     
        








        self.raiz.mainloop()


    def start(self):
        cont=0
        error_dato = False
        try:
            codingrate = int(self.codingraten.get())
            spredingfactor=int(self.spredingfactorn.get())
            bw=int(self.bwn.get())
            preamblelenght= int(self.preamblelenghtn.get())
            setchannel=float(self.setchanneln.get())
            #print setchannel
            crc=self.crcn.get()
            setpower=int(self.setpowern.get())
        except:
            error_dato = True

        if (self.lora.rx==False):
            if not error_dato:
                self.thr=PeriodicThread.PeriodicThread(self.update,0.01)
                self.lora.threadrx=PeriodicThread.PeriodicThread(self.lora.getonePacket,0.01)
                
                self.ax.lines=[]
                self.ax1.lines=[]
                self.lora.queuerx.clear()


                self.lora.setConfiguration(bw,codingrate,spredingfactor,preamblelenght,setchannel,setpower,crc)
                if self.lora.ko==0:
                    self.lora.receive()
                

    
                    # Start threading
                    self.lora.startRx()
                    self.thr.start()
                    self.circle.itemconfig(self.item,fill='green')
                    print('Receiving...........')
                    print('\n')
                    print('\n')
                    cont=1

        if (self.lora.rx==True):
            #c.ON()
            #print('jiji')
            self.lora.stopRx()
            print('Stop receiving...')
            #while (len(self.lora.graph)>0) or (len(self.lora.queuerx)>0):
            #    pass
            l=len(self.lora.graph)
            l1=len(self.lora.queuerx)
            #print l
            #print l1
            #time.sleep(max(l,l1)*0.02)
            self.thr.cancel()
            for i in range(max(l,l1)):
                self.update()
            #print len(self.lora.graph)
            #print len(self.lora.queuerx)
            self.circle.itemconfig(self.item,fill='')
            print('Receiving stopped')
            print('\n')
            print('\n')
            #for l in range(len(self.ax.lines)):
            

            self.lora.rx=False

        if (cont==1):
            self.lora.rx=True

                    


    




    def datalogger(self):
        #if self.lora.rx==True:
        #    self.start()
        filename = fd.asksaveasfilename(filetypes=[("Plain text","*.txt")], defaultextension = "*.txt")
        #print filename
        if filename:
            with open(filename, 'w') as file:
                text=self.text_box.get(1.0, tk.END)
                file.write(text.encode('utf8'))
                #lines=text.split('\n')
                #for l in range(len(lines)):
                #    file.write(lines[l]+'\n')



    
    def TX(self):
        if self.lora.rx==True:
            self.start()
        self.top = tk.Toplevel(self.raiz)
        self.top.geometry("200x50-200+100")
        self.top.transient(self.raiz)
        self.top.grab_set()
        self.appc=Demo(self.top,self)
        #self.dialogo.grab_set()


        

    

         





         


    
    
    def update(self):
        #self.line.set_data([x,x+1],[y,y+1])
        #print self.text_box.yview
        if (len(self.lora.graph)>0):
            a=self.lora.graph.popleft()
            if (a[0]==1):
                self.ax.set_xlim(0,500)
                self.ax1.set_xlim(0,500)

            
            #Graph Rssi
            xmin,xmax=self.ax.get_xlim()
            if a[0]>=xmax:
                self.ax.set_xlim(xmin+10,xmax+10)

            ymin,ymax=self.ax.get_ylim()
            if a[1]>=ymax:
                self.ax.set_ylim(ymin,a[1]+5)
            
            if a[1]<=ymin:
                self.ax.set_ylim(a[1]-5,ymax)

            #Graph Snr
            xmin,xmax=self.ax1.get_xlim()
            if a[0]>=xmax:
                self.ax1.set_xlim(xmin+10,xmax+10)

            ymin,ymax=self.ax1.get_ylim()
            if a[2]>=ymax:
                self.ax1.set_ylim(ymin,a[2]+5)
            
            if a[2]<=ymin:
                self.ax1.set_ylim(a[2]-5,ymax)



            self.ax.plot([a[0]],[a[1]],marker='o',linestyle='-',color='r')
            self.ax1.plot([a[0]],[a[2]],marker='o',linestyle='-',color='g')

        



            self.f.canvas.draw_idle()   #self.f.canvas.draw() petaaaaaa
            #print self.ax.lines
        #app.ax.plot([x,x+1],[y,y+1],marker='o',linestyle='-',color='r')
        if (len(self.lora.queuerx)>0):
            print self.lora.queuerx.popleft()

        
        


    

    def on_closing(self):
        self.lora.stopRx()
        self.thr.cancel()
        self.raiz.destroy()



class Demo():
    def __init__(self,master,parent):
        self.master=master
        self.parent=parent


        self.textn=tk.StringVar(value='')

        self.text=tk.Entry(self.master,textvariable=self.textn,width=30)
        self.send = tk.Button(self.master, text="Send", command=self.send,width=15)

        self.text.pack(side=tk.TOP)
        self.send.pack(side=tk.TOP)

        #self.master.mainloop()

    def send(self):
        
        error_dato = False
        try:
            codingrate = int(self.parent.codingraten.get())
            spredingfactor=int(self.parent.spredingfactorn.get())
            bw=int(self.parent.bwn.get())
            preamblelenght= int(self.parent.preamblelenghtn.get())
            setchannel=float(self.parent.setchanneln.get())
            #print setchannel
            crc=self.parent.crcn.get()
            setpower=int(self.parent.setpowern.get())
        except:
            error_dato = True
        #print error_dato
        if not error_dato:
            #self.parent.circle1.itemconfig(self.parent.item1,fill='green')
            self.parent.lora.setConfiguration(bw,codingrate,spredingfactor,preamblelenght,setchannel,setpower,crc)
            #print type(self.text.get())
            #print self.text.get()
            if self.parent.lora.ko==0:
                #print type(self.textn.get())
                if len(self.textn.get())%2==1:
                    a='0'+self.textn.get()
                else:
                    a=self.textn.get()
                self.parent.lora.upload_buffer(a)
                print 'Message to send:',a
                self.parent.lora.transmit()

    



app=Aplicacion()
#mth = PeriodicThread.PeriodicThread(app.update,1)
#mth.start()
#app.raiz.mainloop()
