import Tkinter as tk
import ttk
import sys
import sx1272 as sx


import PeriodicThread
import matplotlib
from matplotlib.backends.backend_tkagg import FigureCanvasTkAgg, NavigationToolbar2TkAgg

from matplotlib.figure import Figure
#import matplotlib.animation as animation
from matplotlib import style

style.use("ggplot")



#c=sx.SX1272()

class StdRedirector():    
    def __init__(self, text_widget):
        self.text_space = text_widget

    def write(self, string):
        self.text_space.config(state=tk.NORMAL)
        self.text_space.insert("end", string)
        self.text_space.see("end")
        self.text_space.config(state=tk.DISABLED)

class Aplicacion():
    def __init__(self):
        self.raiz = tk.Tk()
        #self.raiz.geometry('850x500')
        self.raiz.title("Sniffer")
        self.raiz.protocol("WM_DELETE_WINDOW", self.on_closing)
        self.thr=PeriodicThread.PeriodicThread(self.update,0.01)
        self.lora=sx.SX1272()

        # Declara variables de control
        
        
        self.codingraten=tk.IntVar(value=5)
        self.spredingfactorn=tk.IntVar(value=7)
        self.bwn=tk.IntVar(value=125)
        self.preamblelenghtn=tk.IntVar(value=65531)
        self.setchanneln=tk.DoubleVar(value=915.0)
        self.crcn=tk.StringVar(value='ON')
        self.setpowern=tk.IntVar(value=14)

        

        #Frames
        self.Frame1 = tk.Frame(self.raiz,bd=2,relief=tk.RAISED)
        self.Frame11 = tk.Frame(self.Frame1,bd=2,relief=tk.RAISED)
        self.Frame12 = tk.Frame(self.Frame1,bd=2,relief=tk.RAISED)
        self.Frame13 = tk.Frame(self.Frame1,bd=2,relief=tk.RAISED) 
        self.Frame14 = tk.Frame(self.Frame1,bd=2,relief=tk.RAISED) 
        self.Frame15 = tk.Frame(self.Frame1,bd=2,relief=tk.RAISED)
        self.Frame16 = tk.Frame(self.Frame1,bd=2,relief=tk.RAISED)    
        self.Frame2 = tk.Frame(self.raiz,bd=2) 
        self.Frame21 = tk.Frame(self.Frame2,bd=2,relief=tk.RAISED) 
        self.Frame22 = tk.Frame(self.Frame2,bd=2,relief=tk.RAISED)
        self.Frame23 = tk.Frame(self.Frame2,bd=2,relief=tk.RAISED)
        self.Frame3 = tk.Frame(self.raiz,bd=2,relief=tk.RAISED)
        self.Frame4 = tk.Frame(self.raiz,bd=2,relief=tk.RAISED)



        #Matplot

        self.f = Figure( figsize=(20, 5), dpi=80 )
        self.ax=self.f.add_subplot(111)
        #self.ax0 = self.f.add_axes( (0.05, .05, .50, .50), axisbg=(.75,.75,.75), frameon=False)
        self.ax.set_xlim(0,500)
        self.ax.set_ylim(-80,-20)
        #self.line,=self.ax.plot([], [], lw=2)
        #self.line.set_data([1,2],[1,2])
        #self.ax.plot([1,2],[20,20],marker='o',linestyle='-',color='r')
        #self.ax.plot(3,20,marker='o',linestyle='--',color='r')

        #self.x=0
        #self.y=0
       

        self.ax.set_xlabel( 'Packet Number' )
        self.ax.set_ylabel( 'RSSI (dbm)' )

        self.canvas = FigureCanvasTkAgg(self.f, master=self.Frame3)
        self.canvas.get_tk_widget().pack(side=tk.TOP, fill=tk.BOTH, expand=1)
        #self.canvas._tkcanvas.pack(side=tk.TOP, fill=tk.BOTH, expand=True)
        #self.canvas.draw()

        #Toolbar
        self.toolbar = NavigationToolbar2TkAgg(self.canvas, self.Frame3)
        #self.toolbar.update()
        self.canvas._tkcanvas.pack(side=tk.TOP, fill=tk.BOTH, expand=True)

        #Textbox
        self.text_box = tk.Text(self.Frame4, state=tk.DISABLED,height=20,width=200)

        sys.stdout = StdRedirector(self.text_box)
        sys.stderr = StdRedirector(self.text_box)

        #Scrollbar
        self.scrollb = tk.Scrollbar(self.Frame4, command=self.text_box.yview,orient=tk.VERTICAL)
        self.text_box['yscrollcommand']=self.scrollb.set



        #Labels
        self.etiq1=tk.Label(self.Frame11,text='Coding rate:')
        self.etiq2=tk.Label(self.Frame11,text='Spreading factor:')
        self.etiq3=tk.Label(self.Frame11,text='Bandwidth:')
        self.etiq4=tk.Label(self.Frame13,text='Preamble lenght:')
        self.etiq5=tk.Label(self.Frame13,text='Channel:')
        self.etiq6=tk.Label(self.Frame13,text='CRC:')
        self.etiq7=tk.Label(self.Frame15,text='Set power:')



        #Inputs
        self.codingrate=ttk.Combobox(self.Frame12,textvariable=self.codingraten,width=10)
        self.codingrate['values']=(5,6,7,8)
        self.spredingfactor=ttk.Combobox(self.Frame12,textvariable=self.spredingfactorn,width=10)
        self.spredingfactor['values']=(7,8,9,10,11,12)
        self.bw=ttk.Combobox(self.Frame12,textvariable=self.bwn,width=10)
        self.bw['values']=(125,250,500)
        self.preamblelenght=tk.Entry(self.Frame14,textvariable=self.preamblelenghtn,width=13)
        self.setchannel=tk.Entry(self.Frame14,textvariable=self.setchanneln,width=13)
        self.crc=ttk.Combobox(self.Frame14,textvariable=self.crcn,width=10)
        self.crc['values']=('ON','OFF')
        self.setpower=tk.Entry(self.Frame16,textvariable=self.setpowern,width=13)
        self.st = tk.Button(self.Frame21, text="Start/Stop", command=self.start,width=15)
        self.data = tk.Button(self.Frame22, text="Data logger", command=self.datalogger,width=15)
        self.tx = tk.Button(self.Frame23, text="TX", command=self.TX,width=15)


        #Positionig labels and inputs
        

        self.etiq1.pack(side=tk.TOP)
        self.etiq2.pack(side=tk.TOP)
        self.etiq3.pack(side=tk.TOP)
        self.codingrate.pack(side=tk.TOP)
        self.spredingfactor.pack(side=tk.TOP)
        self.bw.pack(side=tk.TOP)
        self.etiq4.pack(side=tk.TOP)
        self.etiq5.pack(side=tk.TOP)
        self.etiq6.pack(side=tk.TOP)
        self.preamblelenght.pack(side=tk.TOP)
        self.setchannel.pack(side=tk.TOP)
        self.crc.pack(side=tk.TOP)
        self.etiq7.pack(side=tk.TOP)
        self.setpower.pack(side=tk.TOP)
        self.st.pack()
        self.data.pack()
        self.tx.pack()
        self.text_box.pack(side=tk.LEFT)
        self.scrollb.pack(side=tk.LEFT,expand=tk.YES,fill=tk.Y)




        #Positioning Frames
        self.Frame1.pack(side = tk.TOP)
        self.Frame11.pack(side = tk.LEFT)
        self.Frame12.pack(side = tk.LEFT)
        self.Frame13.pack(side = tk.LEFT)
        self.Frame14.pack(side = tk.LEFT)
        self.Frame15.pack(side = tk.LEFT)
        self.Frame16.pack(side = tk.LEFT)
        self.Frame2.pack(side=tk.TOP)
        self.Frame21.pack(side = tk.LEFT)
        self.Frame22.pack(side = tk.LEFT)
        self.Frame23.pack(side = tk.LEFT)
        self.Frame3.pack(side = tk.TOP)
        self.Frame4.pack(side = tk.TOP)

        
        
        self.raiz.mainloop()


    def start(self):
        cont=0
        error_dato = False
        try:
            codingrate = int(self.codingraten.get())
            spredingfactor=int(self.spredingfactorn.get())
            bw=int(self.bwn.get())
            preamblelenght= int(self.preamblelenghtn.get())
            setchannel=float(self.setchanneln.get())
            #print setchannel
            crc=self.crcn.get()
            setpower=int(self.setpowern.get())
        except:
            error_dato = True

        if (self.lora.rx==False):
            if not error_dato:
                self.thr=PeriodicThread.PeriodicThread(self.update,0.01)
                self.lora.threadrx=PeriodicThread.PeriodicThread(self.lora.getonePacket,0.02)
                self.ax.lines=[]

                self.lora.ON()
                self.lora.setLORA()
                self.lora.setBandwidth(bw)
                self.lora.setCodingRate(codingrate)
                self.lora.setSpreadingFactor(spredingfactor)
                self.lora.setPreambleLength(preamblelenght)
                self.lora.setHeaderON()
                self.lora.setLowDataRateOptimize()
                if crc=='ON':
                    self.lora.setCRC_ON()
                if crc=='OFF':
                    self.lora.setCRC_OFF()
                self.lora.setChannel(setchannel)
                self.lora.setPowerNum(setpower)
                self.lora.receive() # Initialize reception parameters
    
                # Checking configuration
                self.lora.getMode()
                self.lora.getHeader()
                self.lora.getPreambleLength()
                self.lora.getChannel()
                self.lora.getPower()
                self.lora.getCRC()
                

    
                # Start threading
                self.lora.startRx()
                self.thr.start()
                print('Receiving...........')
                print('\n')
                print('\n')
                cont=1

        if (self.lora.rx==True):
            #c.ON()
            #print('jiji')
            self.lora.stopRx()
            print('Stop receiving...')
            while (len(self.lora.graph)>0):
                #print len(self.lora.graph)
                pass
            self.thr.cancel()
            print('Receiving stopped')
            print('\n')
            print('\n')
            #for l in range(len(self.ax.lines)):
            

            self.lora.rx=False

        if (cont==1):
            self.lora.rx=True

                    


    




    def datalogger(self):
        print'h'

    def TX(self):
        print'o'



    
    def update(self):
        #self.line.set_data([x,x+1],[y,y+1])
        #print self.text_box.yview
        if (len(self.lora.graph)>0):
            a=self.lora.graph.popleft()
            if (a[0]==1):
                self.ax.set_xlim(0,500)

            xmin,xmax=self.ax.get_xlim()
            if a[0]>=xmax:
                self.ax.set_xlim(xmin+10,xmax+10)


            self.ax.plot([a[0]],[a[1]],marker='o',linestyle='-',color='r')
            self.f.canvas.draw_idle()   #self.f.canvas.draw() petaaaaaa
            #print self.ax.lines
        #app.ax.plot([x,x+1],[y,y+1],marker='o',linestyle='-',color='r')



        


    def on_closing(self):
        self.lora.stopRx()
        self.thr.cancel()
        self.raiz.destroy()


    



app=Aplicacion()
#mth = PeriodicThread.PeriodicThread(app.update,1)
#mth.start()
#app.raiz.mainloop()