import time
import Adafruit_GPIO as GPIO
import ft
 
# Temporarily disable FTDI serial drivers.
ft.use_FT232H()
 
# Find the first FT232H device.
ft232h= ft.FT232H()
 
# Create a SPI interface from the FT232H using pin 3 (D3) as chip select.
# Use a clock speed of 3mhz, SPI mode 0, and most significant bit first.
spi = ft.SPI(ft232h, cs=3, max_speed_hz=3000000, mode=0, bitorder=ft.MSBFIRST)
 
# Configure digital inputs and outputs using the setup function.
# Note that pin numbers 0 to 15 map to pins D0 to D7 then C0 to C7 on the board.
ft232h.setup(4, GPIO.OUT)   # Make pin D4 a digital input.



# Write three bytes (0x01, 0x02, 0x03) out using the SPI protocol.
spi.writeR([0x01])
response = spi.read(1)

spi.write([0x81,0x00]) #wnr set to 1 for writing in register, so register 0x01 now is 0x81

spi.writeR([0x01])
response1 = spi.read(1)

spi.write([0x81,0x80])
spi.write([0x81,0x81])

spi.writeR([0x01])
response2 = spi.read(1)
print 'response:',
print(hex(response[0]))
print 'response1:',
print(hex(response1[0]))
print 'response2:',
print(hex(response2[0]))

